Unit DelphiInt;

Interface

Uses Classes, Controls, Expert, ComCtrls, SysUtils;

Procedure GenearateDelphiForm ( SourceComponent : TComponent; OutDir, OutFile, UnitName : String);
Procedure GenerateDelphiProc  ( SourceComponent : TComponent; OutStream : TRichEdit );

Implementation

Const
  Information  = '(* Unit created with toolkit 1.0 *)';

Var
  InSection        : Integer;
  GUnitName        : String;
  GSourceComponent : TComponent;

Procedure MyCallBack0( AComponent : TComponent; Var ATag);
Begin
  TRichEdit(ATag).Lines.Add ('  '+AComponent.Name + ' : '+AComponent.ClassName+';');
End;

Procedure MyCallBack1( AComponent : TComponent; Var ATag);
Begin
  If AComponent Is TControl Then
    TRichEdit(ATag).Lines.Add ('  '+AComponent.Name + ' := '+AComponent.ClassName+'.Create('+TControl(AComponent).Parent.Name+');')
  Else
    TRichEdit(ATag).Lines.Add ('  '+AComponent.Name + ' := '+AComponent.ClassName+'.Create('+AComponent.Owner.Name+');');
  If AComponent Is TControl Then
  TRichEdit(ATag).Lines.Add ('  '+AComponent.Name + '.SetBounds('+
                                                         IntToStr(TControl(AComponent).BoundsRect.Left)+','+
                                                         IntToStr(TControl(AComponent).BoundsRect.Top)+','+
                                                         IntToStr(TControl(AComponent).BoundsRect.Right)+','+
                                                         IntToStr(TControl(AComponent).BoundsRect.Bottom)+
                                                         ');' );
End;

Procedure GenerateDelphiProc  ( SourceComponent : TComponent; OutStream : TRichEdit );
Begin
  OutStream.Lines.Add ('Var');
  IterateComponent ( SourceComponent, MyCallBack0, OutStream);
  OutStream.Lines.Add ('Begin');
  IterateComponent ( SourceComponent, MyCallBack1, OutStream);
  OutStream.Lines.Add ('End;');
End;

Function GetFrmString (NumSpace : Integer; SMid : String): String;
Var
   SP : String;
Begin
  SP:='';
  If NumSpace>0 Then
  Begin
    SetLength(SP,NumSpace);
    For NumSpace:=NumSpace DownTo 1 Do SP[NumSpace]:=' ';
  End;
  Result:=SP+SMid;
End;

Function GetFrmStringPascal (NumSpace : Integer; SMid : String): String;
Var
   SP : String;
Begin
  SP:='';
  If NumSpace>0 Then
  Begin
    SetLength(SP,NumSpace);
    For NumSpace:=NumSpace DownTo 1 Do SP[NumSpace]:=' ';
  End;
  Result:=SP+SMid+';'
End;

Procedure IterateAllComponent( AComponent : TComponent; Var ATag);
Begin
End;

Procedure UnitStart ( Var FileOut : Text);
Begin
  WriteLn(FileOut,Information);
  AddReturn (FileOut);
  WriteLn(FileOut,GetFrmStringPascal(0,'Unit ' + GUnitName) );
  AddReturn (FileOut);
End;

Procedure UnitEnd ( Var FileOut : Text);
Begin
  WriteLn(FileOut,'End.');
End;

Procedure WriteCompDef ( AComponent : TComponent; Var ATag);
Begin
  If AComponent.Tag=-123456789 Then Exit;
  WriteLn(Text(ATag),GetFrmStringPascal(4,AComponent.Name+': '+AComponent.ClassName));
End;

Procedure ChangeSection ( SectionNum : Integer; Var FileOut : Text;
                          Var StringOut  : String);
Begin
  InSection:=SectionNum;
  Case InSection Of
    0 : //Interface
    Begin
      WriteLn(FileOut,'Interface' );
      AddReturn (FileOut);
      WriteLn(FileOut,'Type' );
      AddReturn (FileOut);
      WriteLn(FileOut,GetFrmString(2,'T'+GSourceComponent.Name+' = Class(TForm)') );
      IterateComponent ( GSourceComponent, WriteCompDef, FileOut);
      WriteLn(FileOut,GetFrmString(2,'Private') );
      WriteLn(FileOut,GetFrmString(2,'Public') );
      WriteLn(FileOut,GetFrmString(2,'End;') );
      AddReturn (FileOut);
    End;
    1 : //Implementation
    Begin
      WriteLn(FileOut,GetFrmString(0,'Implementation') );
      WriteLn(FileOut,GetFrmString(0,'{$R *.DFM}') );
      AddReturn (FileOut);
    End;
    2 : //Initialization
    Begin
      StringOut := 'Initialization'+ReturnChar;
    End;
  End;
End;

Procedure GenearateDelphiForm ( SourceComponent : TComponent; OutDir, OutFile, UnitName : String);
Var
  GlobFile : Text;
Begin
  WriteComponentResFile(OutDir + OutFile + '.DFM',SourceComponent);

  InSection:=0;
  GUnitName:=UnitName;
  GSourceComponent:=SourceComponent;
  GenerateOutpuFile ( OutDir,
                      OutFile + '.Pas',
                      2,
                      SourceComponent,
                      IterateAllComponent,
                      UnitStart,
                      UnitEnd,
                      ChangeSection);
  Exit;
  Writeln(GlobFile,'Unit ' + UnitName + ';');
  Writeln(GlobFile,'');
  Writeln(GlobFile,'Interface');
  Writeln(GlobFile,'');
  Writeln(GlobFile,'Uses Forms;');
  Writeln(GlobFile,'');
  Writeln(GlobFile,'Type');
  Writeln(GlobFile,SourceComponent.ClassName+'=Class(TForm)');
  //IterateComponent ( TWinControl(SourceComponent), WriteCompDefinition, GlobFile);
  Writeln(GlobFile,'Private');
  Writeln(GlobFile,'{ Private declarations }');
  Writeln(GlobFile,'Public');
  Writeln(GlobFile,'{ Public declarations }');
  Writeln(GlobFile,'End;');
  Writeln(GlobFile,'');
  Writeln(GlobFile,'Var');
  Writeln(GlobFile,SourceComponent.Name+': '+ SourceComponent.ClassName);
  Writeln(GlobFile,'');
  Writeln(GlobFile,'Implementation');
  Writeln(GlobFile,'');
  Writeln(GlobFile,'{$R *.DFM}');
  Writeln(GlobFile,'');
  Writeln(GlobFile,'Initialization');
  Writeln(GlobFile,'');
  Writeln(GlobFile,'End.');
  CloseFile(GlobFile);
End;

End.
